Subject: Re: [PATCH v2] ipv6: fix inconsistent prefix route handling

From: Steven Barth <[email-masked]>
Date: Mon, 17 Feb 2014 15:23:34 +0100

On 17.02.2014 15:08, Hannes Frederic Sowa wrote:
>
> I fear there is currently no combination of ifp->flags which can test for
> that. Your first patch seems to be too dangerous in removing neighbour
> discovery brought in on-link state, I fear. It may even be a problem for
> permanent ones, but that's how it is done, currently.
Yeah the kernel neighbor discovery support is a bit tricky in itself and 
I found myself working around it more often then actually using it (at 
least when doing router-stuff).

>
> Best option would be to fully decouple prefix routes from address handling,
> but that would break current userspace.
>
> Current iproute has support for no-prefix-route address addition (see
> iproute2 commit 58c69b226fb3a ("add support for IFA_F_NOPREFIXROUTE")), so you
> could manage those address and route combination directly from user space.
OK, I will use a workaround for now that removes and readds addresses 
when they should be deprecated instead of just converting permanents to 
non-permanents and maybe later use that new NOPREFIXROUTE feature which 
should come in handy.

>
> So if we want to clean up those routes we either must set IFA_F_PERMANENT to
> the ifp flags of the address in inet6_addr_add and really make sure nothing
> breaks because of this. Or introduce a new flag, like IFA_F_USERINSTALLED e.g.
OK, I will try to think about this when I have some more time to spare 
on this.
Thanks for your help so far.

Steven